// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: aws/ec2/v1/ec2.proto

package ec2v1

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"github.com/golang/protobuf/ptypes"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = ptypes.DynamicAny{}
)

// define the regex for a UUID once up-front
var _ec_2_uuidPattern = regexp.MustCompile("^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$")

// Validate checks the field values on AutoscalingGroupSize with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *AutoscalingGroupSize) Validate() error {
	if m == nil {
		return nil
	}

	// no validation rules for Min

	// no validation rules for Max

	// no validation rules for Desired

	return nil
}

// AutoscalingGroupSizeValidationError is the validation error returned by
// AutoscalingGroupSize.Validate if the designated constraints aren't met.
type AutoscalingGroupSizeValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e AutoscalingGroupSizeValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e AutoscalingGroupSizeValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e AutoscalingGroupSizeValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e AutoscalingGroupSizeValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e AutoscalingGroupSizeValidationError) ErrorName() string {
	return "AutoscalingGroupSizeValidationError"
}

// Error satisfies the builtin error interface
func (e AutoscalingGroupSizeValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sAutoscalingGroupSize.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = AutoscalingGroupSizeValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = AutoscalingGroupSizeValidationError{}

// Validate checks the field values on ResizeAutoscalingGroupRequest with the
// rules defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *ResizeAutoscalingGroupRequest) Validate() error {
	if m == nil {
		return nil
	}

	if len(m.GetName()) < 1 {
		return ResizeAutoscalingGroupRequestValidationError{
			field:  "Name",
			reason: "value length must be at least 1 bytes",
		}
	}

	if len(m.GetRegion()) < 1 {
		return ResizeAutoscalingGroupRequestValidationError{
			field:  "Region",
			reason: "value length must be at least 1 bytes",
		}
	}

	if m.GetSize() == nil {
		return ResizeAutoscalingGroupRequestValidationError{
			field:  "Size",
			reason: "value is required",
		}
	}

	if v, ok := interface{}(m.GetSize()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ResizeAutoscalingGroupRequestValidationError{
				field:  "Size",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// ResizeAutoscalingGroupRequestValidationError is the validation error
// returned by ResizeAutoscalingGroupRequest.Validate if the designated
// constraints aren't met.
type ResizeAutoscalingGroupRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ResizeAutoscalingGroupRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ResizeAutoscalingGroupRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ResizeAutoscalingGroupRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ResizeAutoscalingGroupRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ResizeAutoscalingGroupRequestValidationError) ErrorName() string {
	return "ResizeAutoscalingGroupRequestValidationError"
}

// Error satisfies the builtin error interface
func (e ResizeAutoscalingGroupRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sResizeAutoscalingGroupRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ResizeAutoscalingGroupRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ResizeAutoscalingGroupRequestValidationError{}

// Validate checks the field values on ResizeAutoscalingGroupResponse with the
// rules defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *ResizeAutoscalingGroupResponse) Validate() error {
	if m == nil {
		return nil
	}

	return nil
}

// ResizeAutoscalingGroupResponseValidationError is the validation error
// returned by ResizeAutoscalingGroupResponse.Validate if the designated
// constraints aren't met.
type ResizeAutoscalingGroupResponseValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ResizeAutoscalingGroupResponseValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ResizeAutoscalingGroupResponseValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ResizeAutoscalingGroupResponseValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ResizeAutoscalingGroupResponseValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ResizeAutoscalingGroupResponseValidationError) ErrorName() string {
	return "ResizeAutoscalingGroupResponseValidationError"
}

// Error satisfies the builtin error interface
func (e ResizeAutoscalingGroupResponseValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sResizeAutoscalingGroupResponse.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ResizeAutoscalingGroupResponseValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ResizeAutoscalingGroupResponseValidationError{}

// Validate checks the field values on AutoscalingGroup with the rules defined
// in the proto definition for this message. If any rules are violated, an
// error is returned.
func (m *AutoscalingGroup) Validate() error {
	if m == nil {
		return nil
	}

	// no validation rules for Name

	// no validation rules for Region

	if v, ok := interface{}(m.GetSize()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return AutoscalingGroupValidationError{
				field:  "Size",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	for idx, item := range m.GetInstances() {
		_, _ = idx, item

		if v, ok := interface{}(item).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return AutoscalingGroupValidationError{
					field:  fmt.Sprintf("Instances[%v]", idx),
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	}

	return nil
}

// AutoscalingGroupValidationError is the validation error returned by
// AutoscalingGroup.Validate if the designated constraints aren't met.
type AutoscalingGroupValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e AutoscalingGroupValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e AutoscalingGroupValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e AutoscalingGroupValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e AutoscalingGroupValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e AutoscalingGroupValidationError) ErrorName() string { return "AutoscalingGroupValidationError" }

// Error satisfies the builtin error interface
func (e AutoscalingGroupValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sAutoscalingGroup.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = AutoscalingGroupValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = AutoscalingGroupValidationError{}

// Validate checks the field values on GetInstanceRequest with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *GetInstanceRequest) Validate() error {
	if m == nil {
		return nil
	}

	if len(m.GetInstanceId()) < 1 {
		return GetInstanceRequestValidationError{
			field:  "InstanceId",
			reason: "value length must be at least 1 bytes",
		}
	}

	if len(m.GetRegion()) < 1 {
		return GetInstanceRequestValidationError{
			field:  "Region",
			reason: "value length must be at least 1 bytes",
		}
	}

	return nil
}

// GetInstanceRequestValidationError is the validation error returned by
// GetInstanceRequest.Validate if the designated constraints aren't met.
type GetInstanceRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e GetInstanceRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e GetInstanceRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e GetInstanceRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e GetInstanceRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e GetInstanceRequestValidationError) ErrorName() string {
	return "GetInstanceRequestValidationError"
}

// Error satisfies the builtin error interface
func (e GetInstanceRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sGetInstanceRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = GetInstanceRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = GetInstanceRequestValidationError{}

// Validate checks the field values on GetInstanceResponse with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *GetInstanceResponse) Validate() error {
	if m == nil {
		return nil
	}

	if v, ok := interface{}(m.GetInstance()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return GetInstanceResponseValidationError{
				field:  "Instance",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// GetInstanceResponseValidationError is the validation error returned by
// GetInstanceResponse.Validate if the designated constraints aren't met.
type GetInstanceResponseValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e GetInstanceResponseValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e GetInstanceResponseValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e GetInstanceResponseValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e GetInstanceResponseValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e GetInstanceResponseValidationError) ErrorName() string {
	return "GetInstanceResponseValidationError"
}

// Error satisfies the builtin error interface
func (e GetInstanceResponseValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sGetInstanceResponse.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = GetInstanceResponseValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = GetInstanceResponseValidationError{}

// Validate checks the field values on TerminateInstanceRequest with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *TerminateInstanceRequest) Validate() error {
	if m == nil {
		return nil
	}

	if len(m.GetInstanceId()) < 1 {
		return TerminateInstanceRequestValidationError{
			field:  "InstanceId",
			reason: "value length must be at least 1 bytes",
		}
	}

	if len(m.GetRegion()) < 1 {
		return TerminateInstanceRequestValidationError{
			field:  "Region",
			reason: "value length must be at least 1 bytes",
		}
	}

	return nil
}

// TerminateInstanceRequestValidationError is the validation error returned by
// TerminateInstanceRequest.Validate if the designated constraints aren't met.
type TerminateInstanceRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e TerminateInstanceRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e TerminateInstanceRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e TerminateInstanceRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e TerminateInstanceRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e TerminateInstanceRequestValidationError) ErrorName() string {
	return "TerminateInstanceRequestValidationError"
}

// Error satisfies the builtin error interface
func (e TerminateInstanceRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sTerminateInstanceRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = TerminateInstanceRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = TerminateInstanceRequestValidationError{}

// Validate checks the field values on TerminateInstanceResponse with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *TerminateInstanceResponse) Validate() error {
	if m == nil {
		return nil
	}

	return nil
}

// TerminateInstanceResponseValidationError is the validation error returned by
// TerminateInstanceResponse.Validate if the designated constraints aren't met.
type TerminateInstanceResponseValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e TerminateInstanceResponseValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e TerminateInstanceResponseValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e TerminateInstanceResponseValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e TerminateInstanceResponseValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e TerminateInstanceResponseValidationError) ErrorName() string {
	return "TerminateInstanceResponseValidationError"
}

// Error satisfies the builtin error interface
func (e TerminateInstanceResponseValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sTerminateInstanceResponse.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = TerminateInstanceResponseValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = TerminateInstanceResponseValidationError{}

// Validate checks the field values on RebootInstanceRequest with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *RebootInstanceRequest) Validate() error {
	if m == nil {
		return nil
	}

	if len(m.GetInstanceId()) < 1 {
		return RebootInstanceRequestValidationError{
			field:  "InstanceId",
			reason: "value length must be at least 1 bytes",
		}
	}

	if len(m.GetRegion()) < 1 {
		return RebootInstanceRequestValidationError{
			field:  "Region",
			reason: "value length must be at least 1 bytes",
		}
	}

	return nil
}

// RebootInstanceRequestValidationError is the validation error returned by
// RebootInstanceRequest.Validate if the designated constraints aren't met.
type RebootInstanceRequestValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e RebootInstanceRequestValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e RebootInstanceRequestValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e RebootInstanceRequestValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e RebootInstanceRequestValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e RebootInstanceRequestValidationError) ErrorName() string {
	return "RebootInstanceRequestValidationError"
}

// Error satisfies the builtin error interface
func (e RebootInstanceRequestValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sRebootInstanceRequest.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = RebootInstanceRequestValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = RebootInstanceRequestValidationError{}

// Validate checks the field values on RebootInstanceResponse with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *RebootInstanceResponse) Validate() error {
	if m == nil {
		return nil
	}

	return nil
}

// RebootInstanceResponseValidationError is the validation error returned by
// RebootInstanceResponse.Validate if the designated constraints aren't met.
type RebootInstanceResponseValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e RebootInstanceResponseValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e RebootInstanceResponseValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e RebootInstanceResponseValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e RebootInstanceResponseValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e RebootInstanceResponseValidationError) ErrorName() string {
	return "RebootInstanceResponseValidationError"
}

// Error satisfies the builtin error interface
func (e RebootInstanceResponseValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sRebootInstanceResponse.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = RebootInstanceResponseValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = RebootInstanceResponseValidationError{}

// Validate checks the field values on Instance with the rules defined in the
// proto definition for this message. If any rules are violated, an error is returned.
func (m *Instance) Validate() error {
	if m == nil {
		return nil
	}

	// no validation rules for InstanceId

	// no validation rules for Region

	// no validation rules for State

	// no validation rules for InstanceType

	// no validation rules for PublicIpAddress

	// no validation rules for PrivateIpAddress

	// no validation rules for AvailabilityZone

	// no validation rules for Tags

	return nil
}

// InstanceValidationError is the validation error returned by
// Instance.Validate if the designated constraints aren't met.
type InstanceValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e InstanceValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e InstanceValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e InstanceValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e InstanceValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e InstanceValidationError) ErrorName() string { return "InstanceValidationError" }

// Error satisfies the builtin error interface
func (e InstanceValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sInstance.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = InstanceValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = InstanceValidationError{}

// Validate checks the field values on AutoscalingGroup_Instance with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *AutoscalingGroup_Instance) Validate() error {
	if m == nil {
		return nil
	}

	// no validation rules for Id

	// no validation rules for Zone

	// no validation rules for LaunchConfigurationName

	// no validation rules for Healthy

	// no validation rules for LifecycleState

	return nil
}

// AutoscalingGroup_InstanceValidationError is the validation error returned by
// AutoscalingGroup_Instance.Validate if the designated constraints aren't met.
type AutoscalingGroup_InstanceValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e AutoscalingGroup_InstanceValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e AutoscalingGroup_InstanceValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e AutoscalingGroup_InstanceValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e AutoscalingGroup_InstanceValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e AutoscalingGroup_InstanceValidationError) ErrorName() string {
	return "AutoscalingGroup_InstanceValidationError"
}

// Error satisfies the builtin error interface
func (e AutoscalingGroup_InstanceValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sAutoscalingGroup_Instance.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = AutoscalingGroup_InstanceValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = AutoscalingGroup_InstanceValidationError{}
